// sdl2X example application
//
// I hate this example application. It's too slow, I'm abusing of alpha-blending :P Poor GP2X

#include <time.h>
#include <SDL.h>
#include <SDL_mixer.h>
#include <SDL_ttf.h>

#include "../sdl2X/gp2x.h"
#include "../sdl2X/sdl_gp2x.h"
#include "../sdl2X/sdl_gfx_gp2x.h"
#include "../sdl2X/sdl_joystick_gp2x.h"
#include "../sdl2X/sdl_image_gp2x.h"
#include "../sdl2X/sdl_mixer_gp2x.h"
#include "../sdl2X/sdl_ttf_gp2x.h"

#define SCREEN_WIDTH 320
#define SCREEN_HEIGHT 240
#define SCREEN_DEPTH 16

SDL_Surface *screen;
int fps = 0;

int done = 0;
int x = 120, y = 110;

void MainMenu()
{
	time_t t;
	int frames = 0;
	char fpsmeter[32];

	SDL_Surface *image;
	TTF_Font *font;
	Mix_Music *music;
	Mix_Chunk *chunk;

	// Load image
	image = LoadImage("image.bmp", -1);

	// Load font, 12pt
	font = LoadFont("font.ttf", 20);

	// Load background music
	music = LoadMusic("music.mp3");

	// Load sound
	chunk = LoadChannel("sound.wav");

	// Play music (with fade in effect during 2000ms)
	FadeInMusic(music, -1, 2000);

	while(!done)
	{
		// Get time to calculate FPS
		if(frames == 0) t = time(NULL);

		// Read joystick (DaveC's case 2)
		ReadJoystick(2);

		// If start pressed, quit application
		if(joystart) done = 1;

		// If B pressed, play sound once in the first free channel
		if(joyb) PlayChannel(chunk, -1, 0);

		// If click pressed, zoom image
		if(joyclick) image = ZoomSurface(image, 1.1, 1.1, 1);

		// If L pressed, rotate image to the left
		if(joyl) image = RotateSurface(image, -90, 1);

		// If R pressed, rotate image to the left
		if(joyr) image = RotateSurface(image, 90, 1);

		// If joystick moved
		// joy1 (upleft) - joy2 (up) - joy3 (upright) - joy4 (right)
		// joy5 (downright) - joy6 (down) - joy7 (downleft) - joy8 (left)
		if(joy1) { x--; y--; }
		if(joy2) y--;
		if(joy3) { x++; y--; }
		if(joy4) x++;
		if(joy5) { x++; y++; }
		if(joy6) y++;
		if(joy7) { x--; y++; }
		if(joy8) x--;

		// Draw background
		DrawBoxRGBA(screen, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0xFFFFFFFF);

		// Draw image
		DrawSurfaceCenter(screen, image, 160, 120);

		// Draw regular triangle
		DrawRegularFilledTriangleRGBA(screen, 230, 100, 50, 0x00FF0099);

		// Draw filled circle
		DrawFilledCircleRGBA(screen, 70, 100, 15, 0x0000FFBB);

		// Draw filled ellipse
		DrawFilledEllipseRGBA(screen, 150, 100, 25, 20, 0xFF0000DD);

		// Draw shaded text
		DrawTextBlended(screen, font, "sdl2X Test", 160, 160, 0x000000);

		// Draw box
		DrawBoxWithBorderRGBA(screen, x, y, 40, 40, 0x0000FFAA, 1, 0xFF0000FF);

		// Add one more frame and if has passed a second, calculate frames per second
		frames++;
		if(time(NULL) - t >= 1)
		{
			fps = frames;
			frames = 0;
		}

		// Draw FPS
		sprintf(fpsmeter, "%i FPS", fps);
		DrawTextBlended(screen, font, fpsmeter, 160, 15, 0x000000);

		SDL_Flip(screen);
	}

	// Stop music (with fade out effect during 2000ms)
	FadeOutMusic(2000);

	CloseChannel(chunk);
	CloseMusic(music);

	// Close font
	CloseFont(font);

	// Free surface
	SDL_FreeSurface(image);
}

int main(int argc, char *argv[])
{
	// Initialize SDL
	screen = InitSDL(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_DEPTH);

	// Open joystick device
	JoystickOpen(0);

	// Prepare joystick
	PrepareJoystick();

	// Initialize SDL_ttf
	InitSDL_TTF();

	// Initialize SDL_mixer (22050hz, 2 channels, 4096 buffer)
	InitSDL_mixer(22050, 2, 4096);

	// Allocate 8 mixing channels (for the future xD)
	AllocateChannels(8);

	// Main Menu
	MainMenu();

	// Quit SDL
	QuitSDL();

	// Return to GP2X menu
	ReturnGP2X();

	return 0;
}
